Public WriteFile As Integer
Public BigFont As Integer
Public BigFontString As String

Type MbeEDFiled
    start as integer
    lnge as integer
    ausrichtung as integer
End Type

sub main ' simple main program to demonstrate call to locateElement function
  
   dim TextElem as new mbeElement
   dim Found as long
   dim Msg as string

        CMD$ = Command$
        Art$ = Word$(CMD$,1)
    
        If UCase$(Art$) = "I" Then
            MbeMessagebox "Macro: TextAendern.bas"_
            & Chr$(10) & "Version: 1.1.0"_
            & Chr$(10) & "Stand: 16.06.2000"_
            & Chr$(10) & "Macropfad: Umgebungsvariable TOOLS"_
            & Chr$(10) & "untersttzte Parameter:"_
            & Chr$(10) & "/I Informationen ber das Macro", MBE_InfoIcon
            Exit Sub
        End If

   ' setzt den Lokalisierungsradius auf 0
   MbeState.locateTolerance = 10
   
   Msg = "Text identifizieren / Reset=beenden, Edit Text"

   do ' loop to process individually identified elements
      Found = LocateElement (TextElem, 17, Msg)
      if not Found then exit do             

      ' include required processing code here

      TextElem.display MBE_NormalDraw   ' unhighlight element
   loop 
    MbeWritePrompt
    MbeWriteMessage
end sub
'________________________________________________________________________________________
'
Function LocateElement (Element as mbeElement, elemType as Integer, Prompt as String) as Long

' LocateElement function (from LocateFn.bas file)
' enables location of individual graphic elements using MSbasic
' this function can be pasted into any macro as required
' Mapping with MicroStation, Volume 4: Macro Programming, chapter 4
' A.Bonnici, Nov 1997, geodata@ptbo.igs.net, www.ptbo.igs.net/~geodata 

On Error Goto Fehler

   dim idPoint as mbePoint     'coordinates of user's data point  
   dim filePos as long         'current position in design file
   dim elementFound as Long    'loop continuation flag 
   dim continueScan as Long    'design file scanning status flag    
   Dim elemText as String
   dim elemTextLength as string
   elementFound = FALSE        'set to continue loop 
   continueScan = FALSE        'set to start scan at top of file 
   dim BigFont as Integer
   Dim SaveSettings As Integer

' STEP 1: START SCANNING LOOP

   do while elementFound = FALSE
      mbeStartLocate 0, 0, 0, continueScan 

' STEP 2: SEND DATA POINT
    
      if continueScan then
         call mbeSendDataPoint (idPoint)
      else     
         mbeWritePrompt Prompt
         mbeGetInput MBE_DataPointInput, MBE_ResetInput
       
         if mbeState.inputType = MBE_ResetInput then
            MbeSendCommand "edit Text"
            locateElement = FALSE
            exit function
         end if
          
         stat = mbeState.getInputDataPoint (idPoint)
         mbeSendLastInput   
      end if   ' continue scanning

' STEP 3: CHECK FOR APPROPRIATE ELEMENT
          
      if mbeState.cmdResult <> MBE_AcceptQuery then
         mbeWritePrompt "Text nicht gefunden. Nocheinmal versuchen."
         elementFound = FALSE   ' no element in vicinity
         continueScan = FALSE   ' start over
          
      else
         filepos = Element.fromLocate ()

         if (elemType <> FALSE and Element.type <> elemType) Then

            mbeWritePrompt "Das Element ist kein Text!"
            elementFound = FALSE   ' wrong type
            continueScan = FALSE   ' start over

' STEP 4: GET USER CONFIRMATION

         else
            Element.display MBE_Hilite
            If element.getString (elemText) = MBE_Success Then MbeWriteMessage "Text:" & elemText
            mbeWritePrompt "Akzeptieren / Ablehnen"
            mbeGetInput MBE_DataPointInput, MBE_ResetInput
             
            if mbeState.inputType = MBE_ResetInput Then
               Element.display MBE_NormalDraw
               elementFound = FALSE   ' user rejected
               continueScan = TRUE    ' continue search
               MbeWriteMessage
            else
               elementFound = TRUE    ' proper type and accepted
              ' Dim EDFields() as MbeEDField
              ' If element.getString (elemText,2,EDFields) = MBE_Success Then MbeMessageBox "OK"
               If element.getString (elemText) = MBE_Success Then
                    elemTextLength = Str$(Len(elemText))
                    ReadFile 0
                    BigFont = Val(Trim$(BigFontString))
                    actionButton = mbeOpenModalDialog (1)
                    
                    If SaveSettings = 1 Then
                        BigFontString = Trim$(Str$(BigFont))
                        ReadFile 1
                    End If
                    
                    If actionButton = 4 Then
                        Exit Do
                    End If
                        'elemText = Trim$(elemText)
                        If BigFont = 1 Then elemText = UCase$(elemText)
                        If element.setString (elemText) <> MBE_Success Then
                            MbeMessageBox "Kein Text"
                            Exit Do
                        End If
                    stat = element.rewrite ()
               End If
               LocateElement = TRUE
      
            end if   ' user acceptance 
         end if   ' proper element type  
      end if   ' element located
   loop   ' while element not found

   Element.display MBE_NormalDraw

   mbeWritePrompt
   Exit function
   
 Fehler:
    If Err = 1102 Then Exit function
    stat = MbeMessagebox("Fehler:" & Str$(Err), 2048)
    Err = 0
    resume Next

end function

Sub ReadFile(WriteFile As Integer)
    Dim DateiNr As Integer
    Dim DateiName As String
    Dim TempPath As String
    Dim temp as String
    
    DateiNr = FreeFile
    TempPath = MbeGetConfigVar("MS_TMP")
    DateiName = "SaveSettingsText.dat"
    If MbeFindFile (temp, TempPath & DateiName) = MBE_Success  Then
        If FileLen(TempPath & DateiName) < 3 Then Kill TempPath & DateiName
    End If
    
    If WriteFile = False Then
        If MbeFindFile (temp, TempPath & DateiName) = MBE_Success Then
            Open TempPath & DateiName For Random Access Read As #DateiNr
                Get #DateiNr, 1,BigFontString
            Close
        Else
            ' Defaulteinstellungen
            BigFontString = "1"
        End If
     Else
        If BigFontString = "1" Then
            If MbeFindFile (temp, TempPath & DateiName) = MBE_Success Then Kill TempPath & DateiName
        Else
            Open TempPath & DateiName For Random Access Write As #DateiNr
                Put #DateiNr, 1,BigFontString
            Close
        End If
     End If
     
    WriteFile = False
End Sub

 
 